"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerSomaticVariantLevelQuestions(ProtocolElement):
    """
    The questions for the cancer program exit questionnaire for somatic
    variants
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "validationAssayType",
        "variantActionability",
        "variantDetails",
        "variantTested",
        "variantUsability",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "variantActionability": reports_5_0_0.CancerActionabilitySomatic,
            "variantTested": reports_5_0_0.CancerTested,
            "variantUsability": reports_5_0_0.CancerUsabilitySomatic,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.CancerActionabilitySomatic": reports_5_0_0.CancerActionabilitySomatic,
            "org.gel.models.report.avro.CancerTested": reports_5_0_0.CancerTested,
            "org.gel.models.report.avro.CancerUsabilitySomatic": reports_5_0_0.CancerUsabilitySomatic,
            "org.gel.models.report.avro.CancerSomaticVariantLevelQuestions": reports_5_0_0.CancerSomaticVariantLevelQuestions,
        }

    __slots__ = [
        "validationAssayType",
        "variantActionability",
        "variantDetails",
        "variantTested",
        "variantUsability",
        "otherVariantActionability",
    ]

    def __init__(
        self,
        validationAssayType,
        variantActionability,
        variantDetails,
        variantTested,
        variantUsability,
        otherVariantActionability=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.CancerSomaticVariantLevelQuestions model.

        :param validationAssayType:
            Please enter validation assay type e.g Pyrosequencing, NGS panel,
            COBAS, Sanger sequencing. If not applicable enter NA;
        :type validationAssayType: str
        :param variantActionability:
            Type of potential actionability:
        :type variantActionability: list[CancerActionabilitySomatic]
        :param variantDetails:
            Variant coordinates following format
            `chromosome:position:reference:alternate`
        :type variantDetails: str
        :param variantTested:
            Has this variant been tested by another method (either prior to or
            following receipt of this WGA)?
        :type variantTested: CancerTested
        :param variantUsability:
            How has/will this potentially actionable variant been/be used?
        :type variantUsability: CancerUsabilitySomatic
        :param otherVariantActionability:
            Other information about variant actionability
        :type otherVariantActionability: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
